import { FunctionQueryMatcher, QueryMatcher, RawQuery } from '../types/mock-client';
export declare type TrackerConfig = Record<string, unknown>;
interface Handler<T = any> {
    data: T | ((rawQuery: RawQuery) => T);
    match: FunctionQueryMatcher;
    errorMessage?: string;
    once?: true;
}
declare type ResponseTypes = {
    response: <T = any>(data: Handler<T>['data']) => Tracker;
    responseOnce: <T = any>(data: Handler<T>['data']) => Tracker;
    simulateError: (data: Handler<any>['data']) => Tracker;
    simulateErrorOnce: (data: Handler<any>['data']) => Tracker;
};
export declare class Tracker {
    readonly history: {
        [k: string]: RawQuery[];
    };
    on: {
        [k: string]: (rawQueryMatcher: QueryMatcher) => ResponseTypes;
    };
    private readonly config;
    private responses;
    constructor(trackerConfig: TrackerConfig);
    _handle(rawQuery: RawQuery): Promise<any>;
    reset(): void;
    resetHandlers(): void;
    resetHistory(): void;
    private prepareMatcher;
    private prepareStatement;
    private static applyPostOp;
}
export {};
